/*-------------------------------------------------------------------------*/
/* GNU Prolog                                                              */
/*                                                                         */
/* Part  : WAM to mini-assembler translator                                */
/* File  : bt_string.h                                                     */
/* Descr.: string dico management - header file                            */
/* Author: Daniel Diaz                                                     */
/*                                                                         */
/* Copyright (C) 1999,2000 Daniel Diaz                                     */
/*                                                                         */
/* GNU Prolog is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the   */
/* Free Software Foundation; either version 2, or any later version.       */
/*                                                                         */
/* GNU Prolog is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of              */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        */
/* General Public License for more details.                                */
/*                                                                         */
/* You should have received a copy of the GNU General Public License along */
/* with this program; if not, write to the Free Software Foundation, Inc.  */
/* 59 Temple Place - Suite 330, Boston, MA 02111, USA.                     */
/*-------------------------------------------------------------------------*/

/*---------------------------------*/
/* Constants                       */
/*---------------------------------*/

/*---------------------------------*/
/* Type Definitions                */
/*---------------------------------*/

typedef struct btnode *PBTNode;

typedef struct btnode
    {
     char     *str;
     int       no;
     PBTNode   left;
     PBTNode   right;
    }BTNode;




typedef struct
    {
     BTNode   *tree;
     int       nb_elem;
    }BTString;




/*---------------------------------*/
/* Global Variables                */
/*---------------------------------*/




/*---------------------------------*/
/* Function Prototypes             */
/*---------------------------------*/

void       BT_String_Init       (BTString *bt_str);

BTNode    *BT_String_Add        (BTString *bt_str,char *str);

void       BT_String_List       (BTString *bt_str,void (*fct)());

